diff --git a/tempesta_fw/http.c b/tempesta_fw/http.c
index 9435e5357..f60785aeb 100644
--- a/tempesta_fw/http.c
+++ b/tempesta_fw/http.c
@@ -1677,20 +1677,6 @@ tfw_http_resp_fwd(TfwHttpReq *req, TfwHttpResp *resp)
 	 * Doing ss_close_sync() on client connection's socket is safe
 	 * as long as @req that holds a reference to the connection is
 	 * not freed.
-	 *
-	 * TODO: Responses come from different server connections and on
-	 * different threads/CPUs. This code is called for each response.
-	 * If @seq_queue is empty, then ss_close_sync() may get called
-	 * multiple times, which doesn't look like a reasonable thing to
-	 * do. Perhaps, ss_close_sync() can be called only if ss_close()
-	 * fails. Also, perhaps the state of the client connection can be
-	 * checked in attempt to avoid a call to ss_close() altogether.
-	 * Note that ss_close_sync() is used because otherwise queueing
-	 * of the close() action is not guaranteed. Also note that calling
-	 * of ss_close_sync() multiple times is supported by the code in
-	 * __ss_close() that prevents closing of a socket (and a connection)
-	 * that is closed already. Please see a comment there, and the
-	 * issue #687.
 	 */
 	spin_lock(&cli_conn->seq_qlock);
 	if (unlikely(list_empty(seq_queue))) {
diff --git a/tempesta_fw/sock.c b/tempesta_fw/sock.c
index fca11c42b..c9df42f3f 100644
--- a/tempesta_fw/sock.c
+++ b/tempesta_fw/sock.c
@@ -556,18 +556,23 @@ __ss_close(struct sock *sk, int flags)
 	 * if it's live. However, in some cases this may be called multiple
 	 * times on the same socket. Do it only once for the socket.
 	 *
-	 * TODO: Calling ss_close_sync() multiple times on the same socket
-	 * doesn't look like a reasonable thing to do. Please see the comment
-	 * in tfw_http_resp_fwd() for the reasons this may be called multiple
-	 * times. Perhaps there's a better way. Please see the issue #687.
+	 * We can be called from tcp_v4_rcv() under the socket lock, so lock
+	 * the socket only if it isn't locked. It safe because we just checked
+	 * the socket's CPU.
 	 */
-	bh_lock_sock(sk);
-	if (unlikely(!ss_sock_live(sk))) {
+	if (raw_spin_is_locked(&sk->sk_lock.slock.rlock)) {
+		if (unlikely(!ss_sock_live(sk)))
+			return SS_OK;
+		ss_do_close(sk);
+	} else {
+		bh_lock_sock(sk);
+		if (unlikely(!ss_sock_live(sk))) {
+			bh_unlock_sock(sk);
+			return SS_OK;
+		}
+		ss_do_close(sk);
 		bh_unlock_sock(sk);
-		return SS_OK;
 	}
-	ss_do_close(sk);
-	bh_unlock_sock(sk);
 	if (flags & SS_F_CONN_CLOSE)
 		SS_CALL_GUARD_EXIT(connection_drop, sk);
 	sock_put(sk); /* paired with ss_do_close() */
